<?
if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }

/*
* Joomla Community Builder User Plugin: plug_subscribemailman
* @version $Id: subscribemailman.php,v 1.13 2010/11/05 16:55:28 jhaines Exp $
* @package plug_subscribemailman
* @subpackage cb.subscribemailman.php
* @author Julian Haines (after Morten Holdflod Mller)
* @copyright (C) 2010 Morten Holdflod Mller and Julian Haines
* @license Limited http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

global $_PLUGINS;
// onAfterUserApproval is bugged in CB1.2.3 and responds only on set to
// approve. onBeforeUserApproval does a better job for now.
//$_PLUGINS->registerFunction('onAfterUserApproval', 'afterApproveUser', 'subscribeMailman');
$_PLUGINS->registerFunction('onBeforeUserApproval', 'beforeApproveUser', 'subscribeMailman');
$_PLUGINS->registerFunction('onAfterNewUser', 'afterNewUser', 'subscribeMailman');
$_PLUGINS->registerFunction('onAfterDeleteUser', 'afterDeleteUser', 'subscribeMailman');
$_PLUGINS->registerFunction('onBeforeUserBlocking', 'beforeUserBlocking', 'subscribeMailman');
$_PLUGINS->registerFunction('onAfterUserUpdate', 'afterUpdateUser', 'subscribeMailman');
$_PLUGINS->registerFunction('onAfterUpdateUser', 'afterUpdateUser', 'subscribeMailman');
$_PLUGINS->registerFunction('onUserActive', 'userActive', 'subscribeMailman');
$_PLUGINS->registerFunction('onAfterLogin', 'afterLogin', 'subscribeMailman');

cbimport( 'cb.snoopy' );

// Check for external call to the plugin and handle accordingly.

if (  (cbGetParam($_REQUEST, 'plugin', null) === 'subscribemailman') &&
      (cbGetParam($_REQUEST, 'task', null) === 'pluginclass')  ) {
  plug_subscribemailman_external();
}

// This function handles only external calls to the plugin, where triggers are
// specified in the request, for example from CBSubs URL.
//
// eg: http://<your site>/index.php?option=com_comprofiler&task=pluginclass
//      &plugin=subscribemailman&trigger=onfirstactivation&user_id=[user_id]

function plug_subscribemailman_external() {

  // Get user fields from the database according to specified user_id
  $user = CBuser::getUserDataInstance(cbGetParam($_REQUEST, 'user_id', null));

  // New instance of the subscribeMailman class
  $subscribeMailman = new subscribeMailman;

  // Look for triggers and adjust mailman subscription accordingly
  $trigger = cbGetParam($_REQUEST, 'trigger', null);
  switch (strtolower($trigger)) {
    case 'onfirstactivation' :
      $subscribeMailman->beforeUserBlocking($user,0);
      break;
    
    case 'onrenewal' :
      $subscribeMailman->beforeUserBlocking($user,0);
      break;
      
    case 'ondeactivation' :
      $subscribeMailman->beforeUserBlocking($user,1);
      break;
      
    case 'onexpiration' :
      $subscribeMailman->beforeUserBlocking($user,1);
      break;
  }
}

function plug_subscribemailman_install() {
	$html = ' Thank you for downloading and installing this CB plugin! 
	<p> I want to pass on some credit to the team behind 
	<a href="http://snoopy.sourceforge.net/"> Snoopy, the web client class for PHP  </a>.</p> 
	<p> Remember to set the parameters and publish the plugin </p>';

	return $html; 
}

function plug_subscribemailman_uninstall() {
	return '<p> Thank you for trying this plugin!</p>';
}

class subscribeMailman extends cbEventHandler {

	var $snoopy_instance;
	var $login_cookies_instance;

	function getSnoopy() {
		global $snoopy_instance;
		if (!isSet ($snoopy_instance))
			$snoopy_instance = new Snoopy;
		return $snoopy_instance;
	}

	/**
	 * Constructor
	 */
	function subscribeMailman() {
		$this->cbEventHandler();
	}
  
  function getPlugParameters(){

    // If called externally, not as a plugin, we need to load up the plugin
    // parameters from the database, filling $this->params.
    if (!isset($this->params)) {
      $this->params = new cbParamsBase('');
      $this->params->loadFromDB('subscribemailman');
    }
 
		$params = $this->params;
      
		// Plugin Parameters
		$PlugParams['admin_password'] = $params->get('admin_password', '');
		$PlugParams['admin_url'] = $params->get('admin_url', '');
		$PlugParams['new_invite_only'] = 
        intval($params->get('new_invite_only', '0'));
		$PlugParams['new_welcome_msg'] = 
        intval($params->get('new_welcome_msg', '0'));
		$PlugParams['new_send_notifications_to_list_owner'] = 
        intval($params->get('new_send_notifications_to_list_owner', '0'));
		$PlugParams['delete_send_ack'] = 
        intval($params->get('delete_send_ack', '0'));
		$PlugParams['delete_send_notifications_to_list_owner'] = 
        intval($params->get('delete_send_notifications_to_list_owner', '0'));
		$PlugParams['subscribe_user_opt_in_field'] = 
        $params->get('subscribe_user_opt_in_field', '');
    $PlugParams['update_on_login'] = 
        intval($params->get('update_on_login', '0'));

    return $PlugParams;
  }

  function updateSubscription(&$user, &$old_user, $update_always=FALSE) {

    $params = $this->getPlugParameters();
  
    // Get the user's opt-in preference, if the subscribe_user_opt_in_field
    // has been configured in the back-end. Default to user opted-in otherwise.
    $opt_in_key = $params['subscribe_user_opt_in_field'];
    
    if ( ($opt_in_key != '') && array_key_exists($opt_in_key,$user) ) {
      $user_opted_in = $user->$opt_in_key;
      $old_user_opted_in = $old_user->$opt_in_key;
    } else {
      $user_opted_in = 1;
      $old_user_opted_in = $user_opted_in;
    }
  
    // Subscribe / unsubscribe only if there are changes or if update_always
    // is true
    if  ( $update_always ||
          ($user_opted_in != $old_user_opted_in) ||
          ($user->block != $old_user->block) ||
          ($user->approved != $old_user->approved) ||
          ($user->email != $old_user->email) ||
          ($user->name != $old_user->name) ||
          ($user->confirmed != $old_user->confirmed) ) {

      // Unsubscribe user if blocked, unapproved, unconfirmed, opted-out or
      // changed email or name.
      // Note that the new email address is also unsubscribed (before 
      // again subscribing below). This allows for the name of user associated
      // with an existing email address to be changed where a user has altered
      // their subscribed email address directly with the mailman interface.
      // This shouldn't cause problems since Joomla ensures that email
      // addresses are unique which effectively prevents one user hijacking
      // another's email address.
      if (  !$user_opted_in || $user->block || $user->approved!=1 ||
            ($user->email != $old_user->email) || $user->confirmed!=1 ||
            ($user->name != $old_user->name)  ) {
          $this->unSubscribe($old_user->email);
          $this->unSubscribe($user->email);
      }
      
      // Subscribe user if not blocked, approved, confirmed and opted-in
      // NB: $user->approved==2 for unapproved, ==0 for not yet approved. Must
      // compare against 1 to detect approval!
      if ((!$user->block) && ($user->approved==1) && ($user->confirmed==1) &&
            $user_opted_in) {
        $this->Subscribe($user->email,$user->name);	
      }
    }
  }
   
  // This runs if user approval state is altered through the back-end only
  function beforeApproveUser($user, $actionValue) {
    $this->afterApproveUser($user, $actionValue);
  }
  
  // This runs if user approval state is altered through the back-end only
	function afterApproveUser($user, $approved, $unknown = FALSE) {
    $local_user = $user;
        
    // If user is to be approved
		if ( $approved == 1 ) {
      $local_user->approved = 1;

    // or, user is to be unapproved
    } else {
      $local_user->approved = 0;
    }
    $this->updateSubscription(&$local_user,&$local_user,TRUE);
		return true;
	}

  // This runs if a new user is created through the back-end only
	function afterNewUser(&$user, &$user_extra, $unknown1, $unknown2) {
    $this->updateSubscription(&$user,&$user,TRUE);
		return true;
	}

  // This runs when a new user account is activated, eg. by the user
  // completing registration through the front-end, or confirming email
  // if the latter is required.
	function userActive(&$user, $ui, $cause, $mailToAdmins, $mailToUser) {
    $this->updateSubscription(&$user,&$user,TRUE);
		return true;
	}
  
  // This runs if the user profile is updated through the front or back-end
 	function afterUpdateUser(&$user, &$user_extra, $old_user) {
    $this->updateSubscription(&$user,&$old_user,FALSE);
		return true;
	}

  // This runs if the user is deleted through the back-end
	function afterDeleteUser($user, $unknown) {
    $this->unSubscribe($user->email);
  	return true;
	}

  // This runs if the block state is altered through the back-end only
	function beforeUserBlocking($user, $actionValue) {
    $local_user = $user;
        
    // If user is to be blocked
		if ( $actionValue == 1 ) {
      $local_user->block = 1;

    // or, user unblocked
    } else {
      $local_user->block = 0;
    }
    
    $this->updateSubscription(&$local_user,&$local_user,TRUE);
  	return true;
	}

  // This runs every time the user logs-in through the front-end
  function afterLogin(&$user, $loggedIn) {
    $params = $this->getPlugParameters();
    if ($params['update_on_login']) {
      $this->updateSubscription(&$user,&$user,TRUE);
    }
    return true;
  }
  
  // Submit the mailman admin login form and get cookies
	function mailman_login() {
		global $login_cookies_instance;

		if (!isSet ($login_cookies)) {
      $params = $this->getPlugParameters();
			$submit['adminpw'] = $params['admin_password'];
			$url = $params['admin_url'];

			$s = $this->getSnoopy();
			$s->submit($url, $submit);
      
			while (list ($key, $val) = each($s->headers)) {
        if (strstr($val,':')) {
          list ($title, $value) = explode(':', $val, 2);
          if ($title == 'Set-Cookie') {
            $cookieList = explode(';', $value);
            while (list ($k, $v) = each($cookieList)) {
              if (strstr($v,'=')){
                list ($cookieKey, $cookieVal) = explode('=', trim($v), 2);
                $login_cookies_instance[trim($cookieKey)] = trim($cookieVal);
              }
            }
          }
        }
      }
		}
		return $login_cookies_instance;
	}
  
  // Submit the mailman mass subscription form
	function Subscribe($email, $name) {
		$login_cookies = $this->mailman_login();

    $params = $this->getPlugParameters();
		$url = $params['admin_url'].'/members/add';

		$postdata['subscribe_or_invite'] = $params['new_invite_only'];
		$postdata['send_welcome_msg_to_this_batch'] = $params['new_welcome_msg'];
		$postdata['send_notifications_to_list_owner'] = 
        $params['new_send_notifications_to_list_owner'];
		$postdata['subscribees'] = $name."<".$email.">\n";
		$postdata['invitation'] = "";

		$s = $this->getSnoopy();
		$s->cookies = $login_cookies;
		$s->submittext($url, $postdata);
	}

  // Submit the mailman mass removal form
	function unSubscribe($email) {
		$login_cookies = $this->mailman_login();

    $params = $this->getPlugParameters();
		$url = $params['admin_url'].'/members/remove';

		$postdata['send_unsub_ack_to_this_batch'] = $params['delete_send_ack'];
		$postdata['send_unsub_notifications_to_list_owner'] =
        $params['delete_send_notifications_to_list_owner'];
		$postdata['unsubscribees'] = $email."\n";

		$s = $this->getSnoopy();
		$s->cookies = $login_cookies;
		$s->submittext($url, $postdata);
	}
} // End of subscribeMailman class
?>